<script>
  import { max, extent } from "d3-array";
  import { scaleLinear } from "d3-scale";
  import { area } from "d3-shape";

  // Properties
  export let data = [];
  export let value = (d) => d.total_heating_energy;
  export let maxValue = 0;
  export let selectedCity;
  export let scaleAll;

  // Dimensions
  const width = 560;
  const height = 250;
  const margin = { top: 20, right: 20, bottom: 20, left: 40 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const radius = innerWidth/2


  /**
   * Code for grouping data. Origin = https://stackoverflow.com/questions/14446511/most-efficient-method-to-groupby-on-an-array-of-objects
   * @description
   * Takes an Array<V>, and a grouping function,
   * and returns a Map of the array grouped by the grouping function.
   *
   * @param list An array of type V.
   * @param keyGetter A Function that takes the the Array type V as an input, and returns a value of type K.
   *                  K is generally intended to be a property key of V.
   *
   * @returns Map of the array grouped by the grouping function.
   */
  //export function groupBy<K, V>(list: Array<V>, keyGetter: (input: V) => K): Map<K, Array<V>> {
  //    const map = new Map<K, Array<V>>();
  function groupBy(list, keyGetter) {
      const map = new Map();
      list.forEach((item) => {
          const key = keyGetter(item);
          const collection = map.get(key);
          if (!collection) {
              map.set(key, [item]);
          } else {
              collection.push(item);
          }
      });
      return map;
  }


  let maxValues = Array(16).fill(0);
  let maxR = 100;
  let filteredData = data;
  let groupedData = filteredData;
  let buildingTypes = null;

  $: if (selectedCity) {
    console.log("Selected city: ", selectedCity)
    filteredData = data.filter(d => d.city == selectedCity )
  }

  $: if (filteredData) {
    console.log("Data ready. Grouped data: ", filteredData[0]);
    groupedData = groupBy(filteredData, b => b.buildingtype);
    buildingTypes = Array.from(groupedData.keys());
    // trigger
  }

  $: if (scaleAll) {
    console.log(scaleAll);
    if (scaleAll == "true") {
      buildingTypes.forEach(function(item, index) {
        maxValue = max(filteredData, d => d.total_heating_energy)
        maxValues[index] = maxValue;
        yScales[index] = scaleLinear().domain(0, maxValue).range([innerHeight, 0])
      })
      console.log("Scaling now overall", maxValues)
    }
    else {
      buildingTypes.forEach(function(item, index) {
        // let subset = filteredData.filter(d => d.buildingtype == item);
        maxValue = max(filteredData, d => d.buildingtype == item ? d.total_heating_energy : NaN)
        maxValues[index] = maxValue
        yScales[index] = scaleLinear().domain(0, maxValue).range([innerHeight, 0])
      })
      console.log("Scaling per building type", maxValues)
    }
  }


  // Scales
  const xScale = scaleLinear().domain([0, 31*24]).range([0, innerWidth]);
  let yScales = Array(16).fill(scaleLinear().domain(extent(filteredData, value)).range([innerHeight, 0]));
  $: yScale0 = scaleLinear().domain([0, maxValue]).range([0, innerHeight/20]);
  
  // area  
  $: myGraph = area()
      .x(d => d.x)
      .y0(d => d.y0)
      .y1(d => d.y1); 

  // compute all coords up front
  let fullCoords = Array(16).fill(NaN)
  $: if(buildingTypes && scaleAll) {
    buildingTypes.forEach((item, index) => {
      fullCoords[index] = getCoords(item, index * innerHeight/16)
    })
  }

  function getCoords(buildingType, offset) {
    let buildingData = filteredData.filter(d => d.buildingtype == buildingType);
    let buildingIndex = buildingTypes.indexOf(buildingType);
    let buildingMaxValue = maxValues[buildingIndex];
    let buildingYScale = scaleLinear().domain([0, buildingMaxValue]).range([0, innerHeight/40]);
    let buildingCoords = buildingData.map((d) => {
        let x_coord = xScale(((d.day - 1) * 24 + d.hour));
        let y_value = buildingYScale(d.total_heating_energy);
        return { x: x_coord, y0: (offset-y_value), y1: (offset+y_value) };
      });
    console.log("buildingCoors: ", buildingCoords)
    return buildingCoords;
  }

</script>

<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px">
  <g transform="translate({margin.left},{margin.top})">
    {#each buildingTypes as bt, i }  
      <text x="-50" y={innerHeight/16*i} font-size="6px">{buildingTypes[i]}</text>   
      <path fill="black" stroke="black" stroke-width="1" d="{myGraph(fullCoords[i])}"/>
    {/each}
  </g>
</svg>